/*
  GSPLUS - Advanced Apple IIGS Emulator Environment
  Based on the KEGS emulator written by Kent Dickey
  See COPYRIGHT.txt for Copyright information
	See LICENSE.txt for license (GPL v2)
*/

/* char 0x00 (raw 0x40)  */
	{ 0xc7, 0xbb, 0xab, 0xa3, 0xa7, 0xbf, 0xc3, 0xff },
/* char 0x01 (raw 0x41)  */
	{ 0xef, 0xd7, 0xbb, 0xbb, 0x83, 0xbb, 0xbb, 0xff },
/* char 0x02 (raw 0x42)  */
	{ 0x87, 0xbb, 0xbb, 0x87, 0xbb, 0xbb, 0x87, 0xff },
/* char 0x03 (raw 0x43)  */
	{ 0xc7, 0xbb, 0xbf, 0xbf, 0xbf, 0xbb, 0xc7, 0xff },
/* char 0x04 (raw 0x44)  */
	{ 0x87, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0x87, 0xff },
/* char 0x05 (raw 0x45)  */
	{ 0x83, 0xbf, 0xbf, 0x87, 0xbf, 0xbf, 0x83, 0xff },
/* char 0x06 (raw 0x46)  */
	{ 0x83, 0xbf, 0xbf, 0x87, 0xbf, 0xbf, 0xbf, 0xff },
/* char 0x07 (raw 0x47)  */
	{ 0xc3, 0xbf, 0xbf, 0xbf, 0xb3, 0xbb, 0xc3, 0xff },
/* char 0x08 (raw 0x48)  */
	{ 0xbb, 0xbb, 0xbb, 0x83, 0xbb, 0xbb, 0xbb, 0xff },
/* char 0x09 (raw 0x49)  */
	{ 0xc7, 0xef, 0xef, 0xef, 0xef, 0xef, 0xc7, 0xff },
/* char 0x0a (raw 0x4a)  */
	{ 0xfb, 0xfb, 0xfb, 0xfb, 0xfb, 0xbb, 0xc7, 0xff },
/* char 0x0b (raw 0x4b)  */
	{ 0xbb, 0xb7, 0xaf, 0x9f, 0xaf, 0xb7, 0xbb, 0xff },
/* char 0x0c (raw 0x4c)  */
	{ 0xbf, 0xbf, 0xbf, 0xbf, 0xbf, 0xbf, 0x83, 0xff },
/* char 0x0d (raw 0x4d)  */
	{ 0xbb, 0x93, 0xab, 0xab, 0xbb, 0xbb, 0xbb, 0xff },
/* char 0x0e (raw 0x4e)  */
	{ 0xbb, 0xbb, 0x9b, 0xab, 0xb3, 0xbb, 0xbb, 0xff },
/* char 0x0f (raw 0x4f)  */
	{ 0xc7, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xc7, 0xff },
/* char 0x10 (raw 0x50)  */
	{ 0x87, 0xbb, 0xbb, 0x87, 0xbf, 0xbf, 0xbf, 0xff },
/* char 0x11 (raw 0x51)  */
	{ 0xc7, 0xbb, 0xbb, 0xbb, 0xab, 0xb7, 0xcb, 0xff },
/* char 0x12 (raw 0x52)  */
	{ 0x87, 0xbb, 0xbb, 0x87, 0xaf, 0xb7, 0xbb, 0xff },
/* char 0x13 (raw 0x53)  */
	{ 0xc7, 0xbb, 0xbf, 0xc7, 0xfb, 0xbb, 0xc7, 0xff },
/* char 0x14 (raw 0x54)  */
	{ 0x83, 0xef, 0xef, 0xef, 0xef, 0xef, 0xef, 0xff },
/* char 0x15 (raw 0x55)  */
	{ 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xc7, 0xff },
/* char 0x16 (raw 0x56)  */
	{ 0xbb, 0xbb, 0xbb, 0xbb, 0xbb, 0xd7, 0xef, 0xff },
/* char 0x17 (raw 0x57)  */
	{ 0xbb, 0xbb, 0xbb, 0xab, 0xab, 0x93, 0xbb, 0xff },
/* char 0x18 (raw 0x58)  */
	{ 0xbb, 0xbb, 0xd7, 0xef, 0xd7, 0xbb, 0xbb, 0xff },
/* char 0x19 (raw 0x59)  */
	{ 0xbb, 0xbb, 0xd7, 0xef, 0xef, 0xef, 0xef, 0xff },
/* char 0x1a (raw 0x5a)  */
	{ 0x83, 0xfb, 0xf7, 0xef, 0xdf, 0xbf, 0x83, 0xff },
/* char 0x1b (raw 0x5b)  */
	{ 0x83, 0x9f, 0x9f, 0x9f, 0x9f, 0x9f, 0x83, 0xff },
/* char 0x1c (raw 0x5c)  */
	{ 0xff, 0xbf, 0xdf, 0xef, 0xf7, 0xfb, 0xff, 0xff },
/* char 0x1d (raw 0x5d)  */
	{ 0x83, 0xf3, 0xf3, 0xf3, 0xf3, 0xf3, 0x83, 0xff },
/* char 0x1e (raw 0x5e)  */
	{ 0xff, 0xff, 0xef, 0xd7, 0xbb, 0xff, 0xff, 0xff },
/* char 0x1f (raw 0x5f)  */
	{ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x01 },
/* char 0x20 (raw 0x20)  */
	{ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff },
/* char 0x21 (raw 0x21)  */
	{ 0xef, 0xef, 0xef, 0xef, 0xef, 0xff, 0xef, 0xff },
/* char 0x22 (raw 0x22)  */
	{ 0xd7, 0xd7, 0xd7, 0xff, 0xff, 0xff, 0xff, 0xff },
/* char 0x23 (raw 0x23)  */
	{ 0xd7, 0xd7, 0x83, 0xd7, 0x83, 0xd7, 0xd7, 0xff },
/* char 0x24 (raw 0x24)  */
	{ 0xef, 0xc3, 0xaf, 0xc7, 0xeb, 0x87, 0xef, 0xff },
/* char 0x25 (raw 0x25)  */
	{ 0x9f, 0x9b, 0xf7, 0xef, 0xdf, 0xb3, 0xf3, 0xff },
/* char 0x26 (raw 0x26)  */
	{ 0xdf, 0xaf, 0xaf, 0xdf, 0xab, 0xb7, 0xcb, 0xff },
/* char 0x27 (raw 0x27)  */
	{ 0xef, 0xef, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff },
/* char 0x28 (raw 0x28)  */
	{ 0xef, 0xdf, 0xbf, 0xbf, 0xbf, 0xdf, 0xef, 0xff },
/* char 0x29 (raw 0x29)  */
	{ 0xef, 0xf7, 0xfb, 0xfb, 0xfb, 0xf7, 0xef, 0xff },
/* char 0x2a (raw 0x2a)  */
	{ 0xef, 0xab, 0xc7, 0xef, 0xc7, 0xab, 0xef, 0xff },
/* char 0x2b (raw 0x2b)  */
	{ 0xff, 0xef, 0xef, 0x83, 0xef, 0xef, 0xff, 0xff },
/* char 0x2c (raw 0x2c)  */
	{ 0xff, 0xff, 0xff, 0xff, 0xef, 0xef, 0xdf, 0xff },
/* char 0x2d (raw 0x2d)  */
	{ 0xff, 0xff, 0xff, 0x83, 0xff, 0xff, 0xff, 0xff },
/* char 0x2e (raw 0x2e)  */
	{ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xef, 0xff },
/* char 0x2f (raw 0x2f)  */
	{ 0xff, 0xfb, 0xf7, 0xef, 0xdf, 0xbf, 0xff, 0xff },
/* char 0x30 (raw 0x30)  */
	{ 0xc7, 0xbb, 0xb3, 0xab, 0x9b, 0xbb, 0xc7, 0xff },
/* char 0x31 (raw 0x31)  */
	{ 0xef, 0xcf, 0xef, 0xef, 0xef, 0xef, 0xc7, 0xff },
/* char 0x32 (raw 0x32)  */
	{ 0xc7, 0xbb, 0xfb, 0xe7, 0xdf, 0xbf, 0x83, 0xff },
/* char 0x33 (raw 0x33)  */
	{ 0x83, 0xfb, 0xf7, 0xe7, 0xfb, 0xbb, 0xc7, 0xff },
/* char 0x34 (raw 0x34)  */
	{ 0xf7, 0xe7, 0xd7, 0xb7, 0x83, 0xf7, 0xf7, 0xff },
/* char 0x35 (raw 0x35)  */
	{ 0x83, 0xbf, 0x87, 0xfb, 0xfb, 0xbb, 0xc7, 0xff },
/* char 0x36 (raw 0x36)  */
	{ 0xe3, 0xdf, 0xbf, 0x87, 0xbb, 0xbb, 0xc7, 0xff },
/* char 0x37 (raw 0x37)  */
	{ 0x83, 0xfb, 0xf7, 0xef, 0xdf, 0xdf, 0xdf, 0xff },
/* char 0x38 (raw 0x38)  */
	{ 0xc7, 0xbb, 0xbb, 0xc7, 0xbb, 0xbb, 0xc7, 0xff },
/* char 0x39 (raw 0x39)  */
	{ 0xc7, 0xbb, 0xbb, 0xc3, 0xfb, 0xf7, 0x8f, 0xff },
/* char 0x3a (raw 0x3a)  */
	{ 0xff, 0xff, 0xef, 0xff, 0xef, 0xff, 0xff, 0xff },
/* char 0x3b (raw 0x3b)  */
	{ 0xff, 0xff, 0xef, 0xff, 0xef, 0xef, 0xdf, 0xff },
/* char 0x3c (raw 0x3c)  */
	{ 0xf7, 0xef, 0xdf, 0xbf, 0xdf, 0xef, 0xf7, 0xff },
/* char 0x3d (raw 0x3d)  */
	{ 0xff, 0xff, 0x83, 0xff, 0x83, 0xff, 0xff, 0xff },
/* char 0x3e (raw 0x3e)  */
	{ 0xdf, 0xef, 0xf7, 0xfb, 0xf7, 0xef, 0xdf, 0xff },
/* char 0x3f (raw 0x3f)  */
	{ 0xc7, 0xbb, 0xf7, 0xef, 0xef, 0xff, 0xef, 0xff },
/* char 0x40 (raw 0x14)  */
	{ 0x08, 0x10, 0x6c, 0xfe, 0xfc, 0xfc, 0x7e, 0x6c },
/* char 0x41 (raw 0x11)  */
	{ 0x08, 0x10, 0x6c, 0x82, 0x84, 0x84, 0x52, 0x6c },
/* char 0x42 (raw 0xf5)  */
	{ 0x00, 0x00, 0x40, 0x60, 0x70, 0x78, 0x6c, 0x42 },
/* char 0x43 (raw 0x82)  */
	{ 0xfe, 0x44, 0x28, 0x10, 0x10, 0x28, 0x54, 0xfe },
/* char 0x44 (raw 0xeb)  */
	{ 0x00, 0x02, 0x04, 0x88, 0x50, 0x20, 0x20, 0x00 },
/* char 0x45 (raw 0xe4)  */
	{ 0xfe, 0xfc, 0xfa, 0x36, 0xae, 0xde, 0xde, 0xfe },
/* char 0x46 (raw 0xec)  */
	{ 0xfc, 0xfc, 0xfc, 0xdc, 0x9c, 0x00, 0x9e, 0xde },
/* char 0x47 (raw 0xed)  */
	{ 0xfe, 0x00, 0xfe, 0x00, 0xfe, 0x00, 0x00, 0xfe },
/* char 0x48 (raw 0xee)  */
	{ 0x10, 0x20, 0x40, 0xfe, 0x40, 0x20, 0x10, 0x00 },
/* char 0x49 (raw 0xe9)  */
	{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x54 },
/* char 0x4a (raw 0xef)  */
	{ 0x10, 0x10, 0x10, 0x10, 0x92, 0x54, 0x38, 0x10 },
/* char 0x4b (raw 0xf0)  */
	{ 0x10, 0x38, 0x54, 0x92, 0x10, 0x10, 0x10, 0x10 },
/* char 0x4c (raw 0xf1)  */
	{ 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
/* char 0x4d (raw 0xf7)  */
	{ 0x02, 0x02, 0x02, 0x22, 0x62, 0xfe, 0x60, 0x20 },
/* char 0x4e (raw 0xf6)  */
	{ 0xfc, 0xfc, 0xfc, 0xfc, 0xfc, 0xfc, 0xfc, 0xfc },
/* char 0x4f (raw 0xaf)  */
	{ 0xc8, 0x18, 0x38, 0x7e, 0x38, 0x18, 0x08, 0xf6 },
/* char 0x50 (raw 0xb8)  */
	{ 0x26, 0x30, 0x38, 0xfc, 0x38, 0x30, 0x20, 0xde },
/* char 0x51 (raw 0xce)  */
	{ 0x02, 0x12, 0x10, 0xfe, 0x7c, 0x38, 0x12, 0x02 },
/* char 0x52 (raw 0xe5)  */
	{ 0x02, 0x12, 0x38, 0x7c, 0xfe, 0x10, 0x12, 0x02 },
/* char 0x53 (raw 0xea)  */
	{ 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00 },
/* char 0x54 (raw 0xe6)  */
	{ 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0xfe },
/* char 0x55 (raw 0xe8)  */
	{ 0x10, 0x08, 0x04, 0xfe, 0x04, 0x08, 0x10, 0x00 },
/* char 0x56 (raw 0xd7)  */
	{ 0x54, 0xaa, 0x54, 0xaa, 0x54, 0xaa, 0x54, 0xaa },
/* char 0x57 (raw 0xe3)  */
	{ 0xaa, 0x54, 0xaa, 0x54, 0xaa, 0x54, 0xaa, 0x54 },
/* char 0x58 (raw 0xf4)  */
	{ 0x00, 0x7c, 0x82, 0x80, 0x80, 0x80, 0xfe, 0x00 },
/* char 0x59 (raw 0xe7)  */
	{ 0x00, 0x00, 0xfc, 0x02, 0x02, 0x02, 0xfe, 0x00 },
/* char 0x5a (raw 0xf3)  */
	{ 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02 },
/* char 0x5b (raw 0xd2)  */
	{ 0x10, 0x38, 0x7c, 0xfe, 0x7c, 0x38, 0x10, 0x00 },
/* char 0x5c (raw 0xc7)  */
	{ 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe },
/* char 0x5d (raw 0xd4)  */
	{ 0x28, 0x28, 0xee, 0x00, 0xee, 0x28, 0x28, 0x00 },
/* char 0x5e (raw 0xdf)  */
	{ 0xfe, 0x02, 0x02, 0x32, 0x32, 0x02, 0x02, 0xfe },
/* char 0x5f (raw 0xd1)  */
	{ 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80 },
/* char 0x60 (raw 0x60)  */
	{ 0xdf, 0xef, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff },
/* char 0x61 (raw 0x61)  */
	{ 0xff, 0xff, 0xc7, 0xfb, 0xc3, 0xbb, 0xc3, 0xff },
/* char 0x62 (raw 0x62)  */
	{ 0xbf, 0xbf, 0x87, 0xbb, 0xbb, 0xbb, 0x87, 0xff },
/* char 0x63 (raw 0x63)  */
	{ 0xff, 0xff, 0xc3, 0xbf, 0xbf, 0xbf, 0xc3, 0xff },
/* char 0x64 (raw 0x64)  */
	{ 0xfb, 0xfb, 0xc3, 0xbb, 0xbb, 0xbb, 0xc3, 0xff },
/* char 0x65 (raw 0x65)  */
	{ 0xff, 0xff, 0xc7, 0xbb, 0x83, 0xbf, 0xc3, 0xff },
/* char 0x66 (raw 0x66)  */
	{ 0xe7, 0xdb, 0xdf, 0x87, 0xdf, 0xdf, 0xdf, 0xff },
/* char 0x67 (raw 0x67)  */
	{ 0xff, 0xff, 0xc7, 0xbb, 0xbb, 0xc3, 0xfb, 0xc7 },
/* char 0x68 (raw 0x68)  */
	{ 0xbf, 0xbf, 0x87, 0xbb, 0xbb, 0xbb, 0xbb, 0xff },
/* char 0x69 (raw 0x69)  */
	{ 0xef, 0xff, 0xcf, 0xef, 0xef, 0xef, 0xc7, 0xff },
/* char 0x6a (raw 0x6a)  */
	{ 0xf7, 0xff, 0xe7, 0xf7, 0xf7, 0xf7, 0xb7, 0xcf },
/* char 0x6b (raw 0x6b)  */
	{ 0xbf, 0xbf, 0xbb, 0xb7, 0x8f, 0xb7, 0xbb, 0xff },
/* char 0x6c (raw 0x6c)  */
	{ 0xcf, 0xef, 0xef, 0xef, 0xef, 0xef, 0xc7, 0xff },
/* char 0x6d (raw 0x6d)  */
	{ 0xff, 0xff, 0x93, 0xab, 0xab, 0xab, 0xbb, 0xff },
/* char 0x6e (raw 0x6e)  */
	{ 0xff, 0xff, 0x87, 0xbb, 0xbb, 0xbb, 0xbb, 0xff },
/* char 0x6f (raw 0x6f)  */
	{ 0xff, 0xff, 0xc7, 0xbb, 0xbb, 0xbb, 0xc7, 0xff },
/* char 0x70 (raw 0x70)  */
	{ 0xff, 0xff, 0x87, 0xbb, 0xbb, 0x87, 0xbf, 0xbf },
/* char 0x71 (raw 0x71)  */
	{ 0xff, 0xff, 0xc3, 0xbb, 0xbb, 0xc3, 0xfb, 0xfb },
/* char 0x72 (raw 0x72)  */
	{ 0xff, 0xff, 0xa3, 0x9f, 0xbf, 0xbf, 0xbf, 0xff },
/* char 0x73 (raw 0x73)  */
	{ 0xff, 0xff, 0xc3, 0xbf, 0xc7, 0xfb, 0x87, 0xff },
/* char 0x74 (raw 0x74)  */
	{ 0xdf, 0xdf, 0x87, 0xdf, 0xdf, 0xdb, 0xe7, 0xff },
/* char 0x75 (raw 0x75)  */
	{ 0xff, 0xff, 0xbb, 0xbb, 0xbb, 0xb3, 0xcb, 0xff },
/* char 0x76 (raw 0x76)  */
	{ 0xff, 0xff, 0xbb, 0xbb, 0xbb, 0xd7, 0xef, 0xff },
/* char 0x77 (raw 0x77)  */
	{ 0xff, 0xff, 0xbb, 0xbb, 0xab, 0xab, 0x93, 0xff },
/* char 0x78 (raw 0x78)  */
	{ 0xff, 0xff, 0xbb, 0xd7, 0xef, 0xd7, 0xbb, 0xff },
/* char 0x79 (raw 0x79)  */
	{ 0xff, 0xff, 0xbb, 0xbb, 0xbb, 0xc3, 0xfb, 0xc7 },
/* char 0x7a (raw 0x7a)  */
	{ 0xff, 0xff, 0x83, 0xf7, 0xef, 0xdf, 0x83, 0xff },
/* char 0x7b (raw 0x7b)  */
	{ 0xe3, 0xcf, 0xcf, 0x9f, 0xcf, 0xcf, 0xe3, 0xff },
/* char 0x7c (raw 0x7c)  */
	{ 0xef, 0xef, 0xef, 0xef, 0xef, 0xef, 0xef, 0xef },
/* char 0x7d (raw 0x7d)  */
	{ 0x8f, 0xe7, 0xe7, 0xf3, 0xe7, 0xe7, 0x8f, 0xff },
/* char 0x7e (raw 0x7e)  */
	{ 0xcb, 0xa7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff },
/* char 0x7f (raw 0x7f)  */
	{ 0xff, 0xab, 0xd7, 0xab, 0xd7, 0xab, 0xff, 0xff },
/* char 0x80 (raw 0x40)  */
	{ 0x38, 0x44, 0x54, 0x5c, 0x58, 0x40, 0x3c, 0x00 },
/* char 0x81 (raw 0x41)  */
	{ 0x10, 0x28, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x00 },
/* char 0x82 (raw 0x42)  */
	{ 0x78, 0x44, 0x44, 0x78, 0x44, 0x44, 0x78, 0x00 },
/* char 0x83 (raw 0x43)  */
	{ 0x38, 0x44, 0x40, 0x40, 0x40, 0x44, 0x38, 0x00 },
/* char 0x84 (raw 0x44)  */
	{ 0x78, 0x44, 0x44, 0x44, 0x44, 0x44, 0x78, 0x00 },
/* char 0x85 (raw 0x45)  */
	{ 0x7c, 0x40, 0x40, 0x78, 0x40, 0x40, 0x7c, 0x00 },
/* char 0x86 (raw 0x46)  */
	{ 0x7c, 0x40, 0x40, 0x78, 0x40, 0x40, 0x40, 0x00 },
/* char 0x87 (raw 0x47)  */
	{ 0x3c, 0x40, 0x40, 0x40, 0x4c, 0x44, 0x3c, 0x00 },
/* char 0x88 (raw 0x48)  */
	{ 0x44, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0x00 },
/* char 0x89 (raw 0x49)  */
	{ 0x38, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38, 0x00 },
/* char 0x8a (raw 0x4a)  */
	{ 0x04, 0x04, 0x04, 0x04, 0x04, 0x44, 0x38, 0x00 },
/* char 0x8b (raw 0x4b)  */
	{ 0x44, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0x00 },
/* char 0x8c (raw 0x4c)  */
	{ 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x7c, 0x00 },
/* char 0x8d (raw 0x4d)  */
	{ 0x44, 0x6c, 0x54, 0x54, 0x44, 0x44, 0x44, 0x00 },
/* char 0x8e (raw 0x4e)  */
	{ 0x44, 0x44, 0x64, 0x54, 0x4c, 0x44, 0x44, 0x00 },
/* char 0x8f (raw 0x4f)  */
	{ 0x38, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0x00 },
/* char 0x90 (raw 0x50)  */
	{ 0x78, 0x44, 0x44, 0x78, 0x40, 0x40, 0x40, 0x00 },
/* char 0x91 (raw 0x51)  */
	{ 0x38, 0x44, 0x44, 0x44, 0x54, 0x48, 0x34, 0x00 },
/* char 0x92 (raw 0x52)  */
	{ 0x78, 0x44, 0x44, 0x78, 0x50, 0x48, 0x44, 0x00 },
/* char 0x93 (raw 0x53)  */
	{ 0x38, 0x44, 0x40, 0x38, 0x04, 0x44, 0x38, 0x00 },
/* char 0x94 (raw 0x54)  */
	{ 0x7c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x00 },
/* char 0x95 (raw 0x55)  */
	{ 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0x00 },
/* char 0x96 (raw 0x56)  */
	{ 0x44, 0x44, 0x44, 0x44, 0x44, 0x28, 0x10, 0x00 },
/* char 0x97 (raw 0x57)  */
	{ 0x44, 0x44, 0x44, 0x54, 0x54, 0x6c, 0x44, 0x00 },
/* char 0x98 (raw 0x58)  */
	{ 0x44, 0x44, 0x28, 0x10, 0x28, 0x44, 0x44, 0x00 },
/* char 0x99 (raw 0x59)  */
	{ 0x44, 0x44, 0x28, 0x10, 0x10, 0x10, 0x10, 0x00 },
/* char 0x9a (raw 0x5a)  */
	{ 0x7c, 0x04, 0x08, 0x10, 0x20, 0x40, 0x7c, 0x00 },
/* char 0x9b (raw 0x5b)  */
	{ 0x7c, 0x60, 0x60, 0x60, 0x60, 0x60, 0x7c, 0x00 },
/* char 0x9c (raw 0x5c)  */
	{ 0x00, 0x40, 0x20, 0x10, 0x08, 0x04, 0x00, 0x00 },
/* char 0x9d (raw 0x5d)  */
	{ 0x7c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x7c, 0x00 },
/* char 0x9e (raw 0x5e)  */
	{ 0x00, 0x00, 0x10, 0x28, 0x44, 0x00, 0x00, 0x00 },
/* char 0x9f (raw 0x5f)  */
	{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe },
/* char 0xa0 (raw 0x20)  */
	{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
/* char 0xa1 (raw 0x21)  */
	{ 0x10, 0x10, 0x10, 0x10, 0x10, 0x00, 0x10, 0x00 },
/* char 0xa2 (raw 0x22)  */
	{ 0x28, 0x28, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00 },
/* char 0xa3 (raw 0x23)  */
	{ 0x28, 0x28, 0x7c, 0x28, 0x7c, 0x28, 0x28, 0x00 },
/* char 0xa4 (raw 0x24)  */
	{ 0x10, 0x3c, 0x50, 0x38, 0x14, 0x78, 0x10, 0x00 },
/* char 0xa5 (raw 0x25)  */
	{ 0x60, 0x64, 0x08, 0x10, 0x20, 0x4c, 0x0c, 0x00 },
/* char 0xa6 (raw 0x26)  */
	{ 0x20, 0x50, 0x50, 0x20, 0x54, 0x48, 0x34, 0x00 },
/* char 0xa7 (raw 0x27)  */
	{ 0x10, 0x10, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00 },
/* char 0xa8 (raw 0x28)  */
	{ 0x10, 0x20, 0x40, 0x40, 0x40, 0x20, 0x10, 0x00 },
/* char 0xa9 (raw 0x29)  */
	{ 0x10, 0x08, 0x04, 0x04, 0x04, 0x08, 0x10, 0x00 },
/* char 0xaa (raw 0x2a)  */
	{ 0x10, 0x54, 0x38, 0x10, 0x38, 0x54, 0x10, 0x00 },
/* char 0xab (raw 0x2b)  */
	{ 0x00, 0x10, 0x10, 0x7c, 0x10, 0x10, 0x00, 0x00 },
/* char 0xac (raw 0x2c)  */
	{ 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x20, 0x00 },
/* char 0xad (raw 0x2d)  */
	{ 0x00, 0x00, 0x00, 0x7c, 0x00, 0x00, 0x00, 0x00 },
/* char 0xae (raw 0x2e)  */
	{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00 },
/* char 0xaf (raw 0x2f)  */
	{ 0x00, 0x04, 0x08, 0x10, 0x20, 0x40, 0x00, 0x00 },
/* char 0xb0 (raw 0x30)  */
	{ 0x38, 0x44, 0x4c, 0x54, 0x64, 0x44, 0x38, 0x00 },
/* char 0xb1 (raw 0x31)  */
	{ 0x10, 0x30, 0x10, 0x10, 0x10, 0x10, 0x38, 0x00 },
/* char 0xb2 (raw 0x32)  */
	{ 0x38, 0x44, 0x04, 0x18, 0x20, 0x40, 0x7c, 0x00 },
/* char 0xb3 (raw 0x33)  */
	{ 0x7c, 0x04, 0x08, 0x18, 0x04, 0x44, 0x38, 0x00 },
/* char 0xb4 (raw 0x34)  */
	{ 0x08, 0x18, 0x28, 0x48, 0x7c, 0x08, 0x08, 0x00 },
/* char 0xb5 (raw 0x35)  */
	{ 0x7c, 0x40, 0x78, 0x04, 0x04, 0x44, 0x38, 0x00 },
/* char 0xb6 (raw 0x36)  */
	{ 0x1c, 0x20, 0x40, 0x78, 0x44, 0x44, 0x38, 0x00 },
/* char 0xb7 (raw 0x37)  */
	{ 0x7c, 0x04, 0x08, 0x10, 0x20, 0x20, 0x20, 0x00 },
/* char 0xb8 (raw 0x38)  */
	{ 0x38, 0x44, 0x44, 0x38, 0x44, 0x44, 0x38, 0x00 },
/* char 0xb9 (raw 0x39)  */
	{ 0x38, 0x44, 0x44, 0x3c, 0x04, 0x08, 0x70, 0x00 },
/* char 0xba (raw 0x3a)  */
	{ 0x00, 0x00, 0x10, 0x00, 0x10, 0x00, 0x00, 0x00 },
/* char 0xbb (raw 0x3b)  */
	{ 0x00, 0x00, 0x10, 0x00, 0x10, 0x10, 0x20, 0x00 },
/* char 0xbc (raw 0x3c)  */
	{ 0x08, 0x10, 0x20, 0x40, 0x20, 0x10, 0x08, 0x00 },
/* char 0xbd (raw 0x3d)  */
	{ 0x00, 0x00, 0x7c, 0x00, 0x7c, 0x00, 0x00, 0x00 },
/* char 0xbe (raw 0x3e)  */
	{ 0x20, 0x10, 0x08, 0x04, 0x08, 0x10, 0x20, 0x00 },
/* char 0xbf (raw 0x3f)  */
	{ 0x38, 0x44, 0x08, 0x10, 0x10, 0x00, 0x10, 0x00 },
/* char 0xc0 (raw 0x40)  */
	{ 0x38, 0x44, 0x54, 0x5c, 0x58, 0x40, 0x3c, 0x00 },
/* char 0xc1 (raw 0x41)  */
	{ 0x10, 0x28, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x00 },
/* char 0xc2 (raw 0x42)  */
	{ 0x78, 0x44, 0x44, 0x78, 0x44, 0x44, 0x78, 0x00 },
/* char 0xc3 (raw 0x43)  */
	{ 0x38, 0x44, 0x40, 0x40, 0x40, 0x44, 0x38, 0x00 },
/* char 0xc4 (raw 0x44)  */
	{ 0x78, 0x44, 0x44, 0x44, 0x44, 0x44, 0x78, 0x00 },
/* char 0xc5 (raw 0x45)  */
	{ 0x7c, 0x40, 0x40, 0x78, 0x40, 0x40, 0x7c, 0x00 },
/* char 0xc6 (raw 0x46)  */
	{ 0x7c, 0x40, 0x40, 0x78, 0x40, 0x40, 0x40, 0x00 },
/* char 0xc7 (raw 0x47)  */
	{ 0x3c, 0x40, 0x40, 0x40, 0x4c, 0x44, 0x3c, 0x00 },
/* char 0xc8 (raw 0x48)  */
	{ 0x44, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0x00 },
/* char 0xc9 (raw 0x49)  */
	{ 0x38, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38, 0x00 },
/* char 0xca (raw 0x4a)  */
	{ 0x04, 0x04, 0x04, 0x04, 0x04, 0x44, 0x38, 0x00 },
/* char 0xcb (raw 0x4b)  */
	{ 0x44, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0x00 },
/* char 0xcc (raw 0x4c)  */
	{ 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x7c, 0x00 },
/* char 0xcd (raw 0x4d)  */
	{ 0x44, 0x6c, 0x54, 0x54, 0x44, 0x44, 0x44, 0x00 },
/* char 0xce (raw 0x4e)  */
	{ 0x44, 0x44, 0x64, 0x54, 0x4c, 0x44, 0x44, 0x00 },
/* char 0xcf (raw 0x4f)  */
	{ 0x38, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0x00 },
/* char 0xd0 (raw 0x50)  */
	{ 0x78, 0x44, 0x44, 0x78, 0x40, 0x40, 0x40, 0x00 },
/* char 0xd1 (raw 0x51)  */
	{ 0x38, 0x44, 0x44, 0x44, 0x54, 0x48, 0x34, 0x00 },
/* char 0xd2 (raw 0x52)  */
	{ 0x78, 0x44, 0x44, 0x78, 0x50, 0x48, 0x44, 0x00 },
/* char 0xd3 (raw 0x53)  */
	{ 0x38, 0x44, 0x40, 0x38, 0x04, 0x44, 0x38, 0x00 },
/* char 0xd4 (raw 0x54)  */
	{ 0x7c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x00 },
/* char 0xd5 (raw 0x55)  */
	{ 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0x00 },
/* char 0xd6 (raw 0x56)  */
	{ 0x44, 0x44, 0x44, 0x44, 0x44, 0x28, 0x10, 0x00 },
/* char 0xd7 (raw 0x57)  */
	{ 0x44, 0x44, 0x44, 0x54, 0x54, 0x6c, 0x44, 0x00 },
/* char 0xd8 (raw 0x58)  */
	{ 0x44, 0x44, 0x28, 0x10, 0x28, 0x44, 0x44, 0x00 },
/* char 0xd9 (raw 0x59)  */
	{ 0x44, 0x44, 0x28, 0x10, 0x10, 0x10, 0x10, 0x00 },
/* char 0xda (raw 0x5a)  */
	{ 0x7c, 0x04, 0x08, 0x10, 0x20, 0x40, 0x7c, 0x00 },
/* char 0xdb (raw 0x5b)  */
	{ 0x7c, 0x60, 0x60, 0x60, 0x60, 0x60, 0x7c, 0x00 },
/* char 0xdc (raw 0x5c)  */
	{ 0x00, 0x40, 0x20, 0x10, 0x08, 0x04, 0x00, 0x00 },
/* char 0xdd (raw 0x5d)  */
	{ 0x7c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x7c, 0x00 },
/* char 0xde (raw 0x5e)  */
	{ 0x00, 0x00, 0x10, 0x28, 0x44, 0x00, 0x00, 0x00 },
/* char 0xdf (raw 0x5f)  */
	{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe },
/* char 0xe0 (raw 0x60)  */
	{ 0x20, 0x10, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00 },
/* char 0xe1 (raw 0x61)  */
	{ 0x00, 0x00, 0x38, 0x04, 0x3c, 0x44, 0x3c, 0x00 },
/* char 0xe2 (raw 0x62)  */
	{ 0x40, 0x40, 0x78, 0x44, 0x44, 0x44, 0x78, 0x00 },
/* char 0xe3 (raw 0x63)  */
	{ 0x00, 0x00, 0x3c, 0x40, 0x40, 0x40, 0x3c, 0x00 },
/* char 0xe4 (raw 0x64)  */
	{ 0x04, 0x04, 0x3c, 0x44, 0x44, 0x44, 0x3c, 0x00 },
/* char 0xe5 (raw 0x65)  */
	{ 0x00, 0x00, 0x38, 0x44, 0x7c, 0x40, 0x3c, 0x00 },
/* char 0xe6 (raw 0x66)  */
	{ 0x18, 0x24, 0x20, 0x78, 0x20, 0x20, 0x20, 0x00 },
/* char 0xe7 (raw 0x67)  */
	{ 0x00, 0x00, 0x38, 0x44, 0x44, 0x3c, 0x04, 0x38 },
/* char 0xe8 (raw 0x68)  */
	{ 0x40, 0x40, 0x78, 0x44, 0x44, 0x44, 0x44, 0x00 },
/* char 0xe9 (raw 0x69)  */
	{ 0x10, 0x00, 0x30, 0x10, 0x10, 0x10, 0x38, 0x00 },
/* char 0xea (raw 0x6a)  */
	{ 0x08, 0x00, 0x18, 0x08, 0x08, 0x08, 0x48, 0x30 },
/* char 0xeb (raw 0x6b)  */
	{ 0x40, 0x40, 0x44, 0x48, 0x70, 0x48, 0x44, 0x00 },
/* char 0xec (raw 0x6c)  */
	{ 0x30, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38, 0x00 },
/* char 0xed (raw 0x6d)  */
	{ 0x00, 0x00, 0x6c, 0x54, 0x54, 0x54, 0x44, 0x00 },
/* char 0xee (raw 0x6e)  */
	{ 0x00, 0x00, 0x78, 0x44, 0x44, 0x44, 0x44, 0x00 },
/* char 0xef (raw 0x6f)  */
	{ 0x00, 0x00, 0x38, 0x44, 0x44, 0x44, 0x38, 0x00 },
/* char 0xf0 (raw 0x70)  */
	{ 0x00, 0x00, 0x78, 0x44, 0x44, 0x78, 0x40, 0x40 },
/* char 0xf1 (raw 0x71)  */
	{ 0x00, 0x00, 0x3c, 0x44, 0x44, 0x3c, 0x04, 0x04 },
/* char 0xf2 (raw 0x72)  */
	{ 0x00, 0x00, 0x5c, 0x60, 0x40, 0x40, 0x40, 0x00 },
/* char 0xf3 (raw 0x73)  */
	{ 0x00, 0x00, 0x3c, 0x40, 0x38, 0x04, 0x78, 0x00 },
/* char 0xf4 (raw 0x74)  */
	{ 0x20, 0x20, 0x78, 0x20, 0x20, 0x24, 0x18, 0x00 },
/* char 0xf5 (raw 0x75)  */
	{ 0x00, 0x00, 0x44, 0x44, 0x44, 0x4c, 0x34, 0x00 },
/* char 0xf6 (raw 0x76)  */
	{ 0x00, 0x00, 0x44, 0x44, 0x44, 0x28, 0x10, 0x00 },
/* char 0xf7 (raw 0x77)  */
	{ 0x00, 0x00, 0x44, 0x44, 0x54, 0x54, 0x6c, 0x00 },
/* char 0xf8 (raw 0x78)  */
	{ 0x00, 0x00, 0x44, 0x28, 0x10, 0x28, 0x44, 0x00 },
/* char 0xf9 (raw 0x79)  */
	{ 0x00, 0x00, 0x44, 0x44, 0x44, 0x3c, 0x04, 0x38 },
/* char 0xfa (raw 0x7a)  */
	{ 0x00, 0x00, 0x7c, 0x08, 0x10, 0x20, 0x7c, 0x00 },
/* char 0xfb (raw 0x7b)  */
	{ 0x1c, 0x30, 0x30, 0x60, 0x30, 0x30, 0x1c, 0x00 },
/* char 0xfc (raw 0x7c)  */
	{ 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10 },
/* char 0xfd (raw 0x7d)  */
	{ 0x70, 0x18, 0x18, 0x0c, 0x18, 0x18, 0x70, 0x00 },
/* char 0xfe (raw 0x7e)  */
	{ 0x34, 0x58, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
/* char 0xff (raw 0x7f)  */
	{ 0x00, 0x54, 0x28, 0x54, 0x28, 0x54, 0x00, 0x00 },
